#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# QtTube
#
# Copyright (C) 2007 Siegfried-Angel Gevatter Pujals <siggi.gevatter@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

# Program Access Layer
# This file contains all calls to external programs that involve the use of threads

import threading, subprocess
from os import devnull

class GetDownloadUrl(threading.Thread):
	"""Open a pipe to `youtube-dl' and ask for the download URL of the video."""
	
	def __init__(self, videoId, script):
		
		self.videoId = videoId
		self.script = script
		self.result = None
		
		threading.Thread.__init__(self)
	
	def run(self):
		
		try:
			# Call youtube-dl and ask for the download url
			self.pipe = subprocess.Popen(
					str(self.script) + ' --get-url http://www.youtube.com/watch?v=' + str(self.videoId), 
					shell=True, 
					stdin=None,
					stdout=subprocess.PIPE,
					stderr=open(devnull, 'w'),
				)
			
			# Read the resulting output
			self.result = self.pipe.stdout.readlines()
		
		except IOError:
			pass	# The process was killed, probably because the user closed the GUI
